package me.Demon.DemonShiTu.command;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.guimanager.LookDataGui;
import me.Demon.DemonShiTu.manager.DataManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class AdminCmd implements CommandExecutor , TabCompleter {
    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (!sender.isOp()) {
            return true;
        }
        if(args.length == 0){
            sender.sendMessage("§r");
            sender.sendMessage("§e------- ======= §6拜师系统 - 管理员 §e======= -------");
            sender.sendMessage("§2/stadmin top §f- §2查看师徒排行");
            sender.sendMessage("§2/stadmin jiesuan §f- §2结算师徒收益");
            sender.sendMessage("§2/stadmin lookall §f- §2查看所有师傅档案");
            sender.sendMessage("§2/stadmin delete §e[玩家名] §f- §2删除师傅档案");
            sender.sendMessage("§2/stadmin kick §e[玩家名]  §f- §2将玩家踢出徒弟列表");
            sender.sendMessage("§2/stadmin save  §f- §2保存师徒数据");
            sender.sendMessage("§e------- ======= §6拜师系统 - 管理员 §e======= -------");
            sender.sendMessage("§r");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("save")){
            Main.dataManager.SaveDataManager();
            DemonAPI.sendMessage(sender,"玩家数据已保存.");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("jiesuan")){
            ShiTuAPI.settlementIncome();
            DemonAPI.sendMessage(sender,"已结算上月师徒收益.");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("top")){
            ShiTuAPI.revenueTopList(sender);
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("lookall")){
            LookDataGui.OpenGui((Player) sender);
            return true;
        }
        if(args.length == 2 && args[0].equalsIgnoreCase("delete")){
            String sfname = args[1];
            DataManager dataManager = Main.dataManager;
            if(!ShiTuAPI.isTeacherExit(sfname)){
                DemonAPI.sendMessage(sender,"玩家 §e"+sfname+" §a并未出师.");
                return true;
            }
            dataManager.removeShiFuData(sfname);
            dataManager.SaveDataManager();
            DemonAPI.sendMessage(sender,"玩家 §e"+sfname+" §a的出师档案已清理.");
            return true;
        }
        if(args.length == 2 && args[0].equalsIgnoreCase("kick")){
            String name = args[1];
            DataManager dataManager = Main.dataManager;
            if(!dataManager.isPlayerExitTeacher(name)){
                DemonAPI.sendMessage(sender,"玩家 §e"+name+" §a并未拜师.");
                return true;
            }
            String sfName = dataManager.getTeacherName(name);
            ShiFuData fuData = dataManager.getTeacherData(sfName);
            fuData.removeTudiList(name); // 从师傅的数据中移除该玩家（徒弟）的名字
            fuData.SaveData(); // 保存师傅的数据以反映更改
            DemonAPI.sendMessage(sender,"玩家 §e"+name+" §a已从 §b"+sfName+" §a的徒弟列表脱离.");
            return true;
        }
        return false;
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
        List<String> completions = new ArrayList<>();
        if(args.length == 1){
            completions.add("top");
            completions.add("jiesuan");
            completions.add("lookall");
            completions.add("delete");
            completions.add("kick");
            completions.add("save");
        }else if(args.length == 2){
            String[] onlinePlayers = Bukkit.getOnlinePlayers().stream().map(HumanEntity::getName).toArray(String[]::new);
            completions.addAll(Arrays.asList(onlinePlayers));
        }
        return completions;
    }
}
