package me.Demon.DemonShiTu.command;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Event.DshituEvent;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.guimanager.OnlineTeacherGui;
import me.Demon.DemonShiTu.manager.DataManager;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.List;

public class MainCmd implements CommandExecutor {
    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if(!(sender instanceof Player)){return true;}
        Player p = (Player) sender;
        if(args.length == 0){
            sender.sendMessage("§r");
            sender.sendMessage("§e------- ======= §6斗魂学院等级系统 §e======= -------");
            sender.sendMessage("§2/st open §f- §2查看在线师傅名单");
            sender.sendMessage("§2/st §e[师傅名] §f- §2向其他玩家拜师");
            sender.sendMessage("§e------- ======= §6斗魂学院等级系统 §e======= -------");
            sender.sendMessage("§r");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("open")){
            OnlineTeacherGui.OpenGui(p);
            return true;
        }else{
            String name = p.getName();
            String sfName = args[0];
            long joinTime = p.getFirstPlayed();// 获取玩家加入服务器的时间
            // 计算玩家已加入服务器超过多少天 (当前时间 - 加入时间)
            int joinDay = (int) ((System.currentTimeMillis() - joinTime) / 1000 / (24*60*60));
            // 超过天数的阈值
            int maxJoinDays = 15;
            if(joinDay >= maxJoinDays){
                DemonAPI.sendMessage(p,"非常抱歉,你已经加入服务器§e<"+maxJoinDays+"天>§a已经不能拜师了.", Sound.ENTITY_VILLAGER_NO);
                return true;
            }
            // 判断玩家是否已经出师
            if(ShiTuAPI.isTeacherExit(name)){
                DemonAPI.sendMessage(p,"非常抱歉,你已 §e出师 §a无法成为其他人的徒弟.", Sound.ENTITY_VILLAGER_NO);
                return true;
            }
            DataManager dataManager = Main.dataManager;
            // 判断玩家是否已经拜师
            if(dataManager.isPlayerExitTeacher(name)){
                DemonAPI.sendMessage(p,"非常抱歉,每名玩家只能拜一位师傅.", Sound.ENTITY_VILLAGER_NO);
                return true;
            }
            List<String> applicationList = dataManager.getApplyForList(sfName);// 获取申请列表
            if(applicationList.contains(name)){
                DemonAPI.sendMessage(p,"你已经发送过拜师请求，请耐心等待对方同意。", Sound.ENTITY_VILLAGER_NO);
                return true;
            }
            applicationList.add(name);// 将玩家加入申请列表
            dataManager.setApplyForList(sfName,applicationList); // 刷新申请列表
            DemonAPI.sendMessage(p,"成功发送拜师请求，请耐心等待对方同意。",Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
            Player sfPlayer = Bukkit.getPlayer(sfName);
            if(sfPlayer != null){
                DemonAPI.sendMessage(sfPlayer,"您新收到有一条拜师请求等待处理.",Sound.ENTITY_VILLAGER_YES);
            }
            DshituEvent event = new DshituEvent(p,sfName);
            Bukkit.getPluginManager().callEvent(event);
        }
        return false;
    }
}
