package me.Demon.DemonShiTu.data;

import me.Demon.DemonShiTu.Main;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.List;

public class ShiFuData {

    private String name; // 师傅名
    private int level; // 师傅等级
    private double earnings; // 徒弟收益
    private List<String> tudiList; // 徒弟列表
    private long loginTime;

    public ShiFuData(String name, int level, double earnings, List<String> apprenticeList, long loginTime){
        this.name = name;
        this.level = level;
        this.earnings = earnings;
        this.tudiList = apprenticeList;
        this.loginTime = loginTime;
    }

    public void SaveData(){
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("ShiTuData."+name,null);
        yml.set("ShiTuData."+name+".level",level);
        yml.set("ShiTuData."+name+".shouyi",earnings);
        yml.set("ShiTuData."+name+".loginTime",loginTime);
        yml.set("ShiTuData."+name+".tudi",tudiList);
        Main.plugin.saveConfig();
    }

    public int getLevel() {
        return level;
    }

    public String getName() {
        return name;
    }

    public double getEarnings() {
        return earnings;
    }

    public void setEarnings(double earnings) {
        this.earnings = earnings;
    }

    public void addEarnings(double earnings){
        this.earnings += earnings;
    }

    public long getLoginTime() {
        return loginTime;
    }

    public boolean isLoginOvertime(){
        // 最后一次记录时间距离现在时间超过15天  返回true
        // 获取当前时间的时间戳
        long currentTime = System.currentTimeMillis();
        // 7天的毫秒数
        long fifteenDaysInMillis = 15L * 24 * 60 * 60 * 1000;
        // 检查上次登录时间是否超过15天
        return (currentTime - this.loginTime) > fifteenDaysInMillis;
    }

    public void setLoginTime(long loginTime) {
        this.loginTime = loginTime;
    }

    public List<String> getTudiList() {
        return tudiList;
    }
    public boolean isTudiListExit(String tudiName){
        if(getTudiList().contains(tudiName)){
            return true;
        }
        return false;
    }
    public void addTudiList(String tudiName){
        if(!isTudiListExit(tudiName)) {
            List<String> stringList = getTudiList();
            stringList.add(tudiName);
            setTudiList(stringList);
        }
    }
    public void removeTudiList(String tudiName){
        if(isTudiListExit(tudiName)) {
            List<String> stringList = getTudiList();
            stringList.remove(tudiName);
            setTudiList(stringList);
        }
    }

    public void setTudiList(List<String> tudiList) {
        this.tudiList = tudiList;
    }
}
