package me.Demon.DemonShiTu.guimanager;

import com.yaohun.aurechargedata.api.RechargeAPI;
import com.yaohun.aurechargedata.util.TimeType;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonMonethyCard.api.CardAPI;
import me.Demon.DemonOnlineTime.DtimeAPI;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.manager.DataManager;
import me.Demon.DemonShiTu.util.StackLibrary;
import net.minecraft.server.v1_12_R1.NBTTagCompound;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.time.DayOfWeek;
import java.time.Instant;
import java.time.LocalDate;
import java.time.ZoneId;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

public class TeacherGui implements Listener {

    public static String invTitle = "师徒系统 - 管理系统";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        Player player = (Player) e.getWhoClicked();
        String sfName = player.getName();
        Inventory inv = e.getInventory();
        int rawSlot = e.getRawSlot();
        ItemStack item = e.getCurrentItem();
        if(inv != null && inv.getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
            DataManager dataManager = Main.dataManager;
            if(e.getRawSlot() == 5){
                // 获取徒弟列表
                ShiFuData fuData = dataManager.getTeacherData(sfName);
                List<String> tudiList = fuData.getTudiList();
                if(tudiList.size() < 1) {
                    DemonAPI.sendMessage(player,"你还没有收徒喔,无法获得任何收益。",Sound.ENTITY_VILLAGER_NO);
                    return;
                }
                int time = DtimeAPI.getTime(sfName);
                if(time < 60) {
                    DemonAPI.sendMessage(player,"需要在线达到<§e§l60分钟§a>才能领取收益。",Sound.ENTITY_VILLAGER_NO);
                    return;
                }
                int sfLevel = fuData.getLevel(); // 获取师傅的等级
                double defaultBonus = 5; // 默认奖金
                // 根据师傅的等级设置奖金
                if (sfLevel == 2) {
                    defaultBonus = 10;
                } else if (sfLevel == 3) {
                    defaultBonus = 15;
                } else if (sfLevel == 4) {
                    defaultBonus = 20;
                } else if (sfLevel >= 5) {
                    defaultBonus = 30;
                }
                int needTime = 180; // 活跃所需在线时间（分钟）
                double addMoney = 0; // 粉丝收益（元）
                // 遍历徒弟名单
                for (String name : tudiList) {
                    if (!dataManager.isActiveReward(name)) { // 检查徒弟是否已领取活跃奖励
                        int onlineTime = DtimeAPI.getTime(name); // 获取徒弟的在线时间

                        // 如果徒弟在线时间达到要求
                        if (onlineTime >= needTime) {
                            List<String> activeRewardList = dataManager.getActiveReward(); // 获取活跃奖励名单
                            activeRewardList.add(name); // 将徒弟添加到活跃奖励名单中
                            dataManager.setActiveReward(activeRewardList); // 更新活跃奖励名单
                            addMoney += defaultBonus; // 累计奖金
                        }
                    }
                }
                // 如果累计奖金不足 1 元
                if (addMoney < 1) {
                    DemonAPI.sendMessage(player, "暂时还没有任何徒弟活跃收益可领取...等等再来吧...", Sound.ENTITY_VILLAGER_NO);
                    return;
                }
                // 获取当前日期的星期
                DayOfWeek currentDayOfWeek = LocalDate.now().getDayOfWeek();
                // 如果今天是周一至周五，奖金提高30%
                if (currentDayOfWeek != DayOfWeek.SATURDAY && currentDayOfWeek != DayOfWeek.SUNDAY) {
                    addMoney *= 1.3;
                }
                //判断玩家是否是月卡用户 并且还有时间
                String yueka_text = "";
                if(CardAPI.isCardHaoHua(sfName)){
                    addMoney *= 1.2;
                    yueka_text = "§7(§e豪华月卡§7) ";
                }else if(CardAPI.isCardJingDian(sfName)){
                    addMoney *= 1.1;
                    yueka_text = "§7(§b经典月卡§7) ";
                }
                // 获取这个师傅上面是否还有师傅
                if(!dataManager.isPlayerExitTeacher(sfName)){
                    fuData.addEarnings(addMoney);
                    fuData.SaveData();
                    DemonAPI.sendMessage(player,"成功领取徒弟活跃收益: §6"+addMoney+"师徒币"+yueka_text,Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                    System.out.println("[师徒] 活跃激励 玩家 <" + sfName + ">获得" + addMoney + "师徒币奖励");
                }else{
                    double newMoney = (addMoney / 2);
                    fuData.addEarnings(newMoney);
                    fuData.SaveData();
                    DemonAPI.sendMessage(player,"成功领取徒弟活跃收益: §6"+newMoney+"师徒币"+yueka_text,Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                    String sfNameB = dataManager.getTeacherName(sfName);
                    ShiFuData fuDataB = dataManager.getTeacherData(sfNameB);
                    fuDataB.addEarnings(newMoney);
                    fuDataB.SaveData();
                    Player shifuBPlayer = Bukkit.getPlayer(fuDataB.getName());
                    if(shifuBPlayer != null){
                        DemonAPI.sendMessage(shifuBPlayer,"获得徒弟的活在线跃激励收益: §6"+newMoney+"师徒币",Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                    }
                    System.out.println("[师徒] 活跃激励 玩家<" + sfName + ">和<"+sfNameB+">各获得" + newMoney + "师徒币奖励");
                }
                TeacherGui.OpenGui(player);
            }
            if(rawSlot == 7){
                ThApplyGui.OpenGui(player);
                player.playSound(player.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1.6F,1.8F);
            }
            if(rawSlot >= 18 && rawSlot < inv.getSize()){
                if(DemonAPI.itemIsNull(item)){return;}
                NBTTagCompound nbt = StackLibrary.getNBT(item);
                if(nbt.hasKey("tdName")){
                    String name = nbt.getString("tdName");
                    // 根据师傅的名字从数据管理器中获取师傅的数据
                    ShiFuData fuData = dataManager.getTeacherData(sfName);
                    // 从师傅的数据中移除该玩家（徒弟）的名字
                    fuData.removeTudiList(name);
                    // 保存师傅的数据以反映更改
                    fuData.SaveData();
                    Player tDPlayer = Bukkit.getPlayer(name);
                    if (tDPlayer != null) {
                        DemonAPI.sendMessage(tDPlayer,"您的师傅 §e" + name + " §a已与你解除师徒关系。",Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                    }
                    DemonAPI.sendMessage(player,"成功与 §e" + name + " §a解除师徒关系。",Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                    TeacherGui.OpenGui(player);
                }
            }
        }
    }

    public static void OpenGui(Player player){
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        for (int i = 0; i < 9; i++) {
            int data = (int) (Math.random() * 6);
            inv.setItem(i, DemonAPI.glass(data,"§r "));
        }
        for (int i = 9; i < 18; i++) {
            inv.setItem(i, DemonAPI.glass(15,"§a§l↓↓§6徒弟列表§a§l↓↓"));
        }
        DataManager dataManager = Main.dataManager;
        ShiFuData shiFuData = dataManager.getTeacherData(player.getName());
        inv.setItem(1,StackLibrary.teacherInfoShow());
        inv.setItem(3,personalInformation(shiFuData));
        inv.setItem(5,earningsRefresh());
        inv.setItem(7,requestProcessing());
        List<String> tuDiList = shiFuData.getTudiList();
        for (String name : tuDiList){
            inv.addItem(apprenticeInformation(name));
        }
        long monthlyTimeLog = dataManager.getMonthlyTimeLog();
        // 检查当前时间是否已经是次月并且超过中午12点
        if (isNextMonth(monthlyTimeLog) && isAfterNoon()) {
            ShiTuAPI.settlementIncome();
            System.out.println("[调试 - 师徒] 已自动结算每月师徒收益");
            dataManager.setMonthlyTimeLog(System.currentTimeMillis());
        }
        long everydayTimeLog = dataManager.getEverydayTimeLog();
        if(!isSameDay(everydayTimeLog,System.currentTimeMillis())){
            System.out.println("[调试 - 师徒] 已清理每日活跃激励奖名单");
            dataManager.setActiveReward(new ArrayList<>());
            dataManager.setEverydayTimeLog(System.currentTimeMillis());
        }
        player.openInventory(inv);
    }

    private static boolean isSameDay(long timestamp1, long timestamp2) {
        LocalDate date1 = Instant.ofEpochMilli(timestamp1).atZone(ZoneId.systemDefault()).toLocalDate();
        LocalDate date2 = Instant.ofEpochMilli(timestamp2).atZone(ZoneId.systemDefault()).toLocalDate();
        return date1.equals(date2);
    }

    private static boolean isNextMonth(long lastTimeLog) {
        Calendar lastCalendar = Calendar.getInstance();
        lastCalendar.setTimeInMillis(lastTimeLog);
        int lastMonth = lastCalendar.get(Calendar.MONTH);
        int currentMonth = Calendar.getInstance().get(Calendar.MONTH);
        return currentMonth != lastMonth;
    }

    private static boolean isAfterNoon() {
        Calendar calendar = Calendar.getInstance();
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        return hour >= 12;
    }

    public static ItemStack personalInformation(ShiFuData fuData){
        ItemStack item = new ItemStack(449, 1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§e§l个人收益查看");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★§7名称: §6§l"+ fuData.getName());
        lore.add("§a§l★§7级别: §6§lLv."+ fuData.getLevel());
        lore.add("§a§l★§7徒弟: §6§l"+ fuData.getTudiList().size() +"名");
        lore.add("§a§l★§7收益: §6§l"+ String.format("%.1f",fuData.getEarnings()) +"师徒币");
        lore.add("§a§l★§7最后一次上线: §c"+DemonAPI.LongToStringData(fuData.getLoginTime(),"yyyy年MM月dd日 HH:mm"));
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack apprenticeInformation(String name){
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§a§l★§7名称: §6§l"+name);
        List<String> lore = new ArrayList<>();
        int levels = (int) DLevelAPI.getOffPlayer_Level(name);
        lore.add("§a§l★§7级别: §dLv."+ levels);
        int time = DtimeAPI.getTime(name);
        lore.add("§a§l★§7今日活跃: §a"+ time+"分钟");
        if(ShiTuAPI.isTeacherExit(name)) {
            ShiFuData fuDataB = Main.dataManager.getTeacherData(name);
            lore.add("§a§l★§7收徒数量: §e" + fuDataB.getTudiList().size() + "名");
        }else{
            lore.add("§a§l★§7收徒数量: §e尚未出师");
        }
        int rechargeMonth = RechargeAPI.getRechargeData(name, TimeType.MONTHLY);
        lore.add("§a§l★§7本月充值: §b" + rechargeMonth + "软妹币");
        lore.add(" ");
        lore.add("§e§l★§7点击解除师徒关系");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbti = StackLibrary.getNBT(item);
        nbti.setString("tdName",name);
        return StackLibrary.setNBT(item, nbti);
    }

    public static ItemStack earningsRefresh(){
        ItemStack item = new ItemStack(347, 1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§7[§6活跃§7] §a徒弟活跃收益");
        List<String> Lore = new ArrayList<>();
        Lore.add("§7§l★§7点击刷新收益");
        meta.setLore(Lore);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack requestProcessing(){
        ItemStack item = new ItemStack(421);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§8« §e处理拜师请求 §8»");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击进行处理 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
