package me.Demon.DemonShiTu.guimanager;

import com.yaohun.aurechargedata.api.RechargeAPI;
import com.yaohun.aurechargedata.util.TimeType;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonOnlineTime.DtimeAPI;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.manager.DataManager;
import me.Demon.DemonShiTu.util.StackLibrary;
import net.minecraft.server.v1_12_R1.NBTTagCompound;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class ThApplyGui implements Listener {

    public static String invTitle = "师徒系统 - 处理拜师申请";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        String sfName = p.getName();
        Inventory inv = e.getInventory();
        int rawSlot = e.getRawSlot();
        ItemStack item = e.getCurrentItem();
        if(inv != null && inv.getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
            if(!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)){
                if (e.getRawSlot() == 31) {
                    TeacherGui.OpenGui(p);
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1.6F,1.8F);
                }
                if(rawSlot >= 0 && rawSlot < 27) {
                    DataManager dataManager = Main.dataManager;
                    if(!ShiTuAPI.isTeacherExit(sfName)){
                        DemonAPI.sendMessage(p,"你需要出师后才能进行操作.",Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    ShiFuData fuData = dataManager.getTeacherData(sfName);
                    NBTTagCompound nbt = StackLibrary.getNBT(item);
                    if (nbt.hasKey("ApplyName")) {
                        String name = nbt.getString("ApplyName");
                        // 获取申请名单 并清理这个玩家 刷新申请列表
                        List<String> applyList = dataManager.getApplyForList(sfName);
                        applyList.remove(name);
                        dataManager.setApplyForList(sfName,applyList);
                        if(e.getClick() == ClickType.LEFT){
                            int tudiLimitAmount = 18;
                            if(fuData.getTudiList().size() >= tudiLimitAmount){
                                DemonAPI.sendMessage(p,"您当前最多可收<§e§l"+tudiLimitAmount+"名§a>徒弟.",Sound.ENTITY_VILLAGER_NO);
                                return;
                            }
                            // 检测玩家是否已拜师
                            if(dataManager.isPlayerExitTeacher(name)){
                                DemonAPI.sendMessage(p,"下手慢了 §e"+name+" §a已经拜其他人为师了.",Sound.ENTITY_VILLAGER_NO);
                                return;
                            }
                            fuData.addTudiList(name); // 将玩家列入徒弟列表
                            Player player = Bukkit.getPlayer(name);
                            if (player != null) {
                                DemonAPI.sendMessage(player,"§6"+sfName+" §a已同意你的拜师请求.");
                                player.sendTitle("§a拜师成功！","§b您的师傅: §f"+sfName);
                            }
                            DemonAPI.sendMessage(p,"玩家 §e"+name+" §a已成为你的徒弟.");
                        }else if(e.getClick() == ClickType.RIGHT){
                            Player player = Bukkit.getPlayer(name);
                            if (player != null) {
                                DemonAPI.sendMessage(player,"§6"+sfName+" §a拒绝了你的拜师请求.");
                            }
                            DemonAPI.sendMessage(p,"已婉拒 §e"+name+" §a成为你的徒弟.");
                        }
                        ThApplyGui.OpenGui(p);
                    }
                }
            }
        }
    }

    public static void OpenGui(Player player){
        String sfName = player.getName();
        // 检测玩家是否已成为师傅
        if(!ShiTuAPI.isTeacherExit(sfName)){
            DemonAPI.sendMessage(player,"你需要 §e出师 §a后才能查看.");
            return;
        }
        DataManager dataManager = Main.dataManager;
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        // 获取申请拜师名单
        List<String> applyList = dataManager.getApplyForList(sfName);
        for (String name : applyList){
            inv.addItem(showItems(name));
        }
        for (int i = 27; i < 36; i++) {
            inv.setItem(i, DemonAPI.glass(15, "§7[[§a▧§c▧§a▧§7]]"));
        }
        inv.setItem(31, StackLibrary.Back_book());
        player.openInventory(inv);
    }

    public static ItemStack showItems(String playName){
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        List<String> lore = new ArrayList<>();
        meta.setDisplayName("§a§l★§7名称: §e"+playName);
        Player player = Bukkit.getPlayer(playName);
        if(player != null) {
            lore.add("§a§l★§7状态: §a§l在线");
        }else{
            lore.add("§a§l★§7状态: §c§l离线");
        }
        int levels = (int) DLevelAPI.getOffPlayer_Level(playName);
        lore.add("§a§l★§7级别: §dLv."+ levels);
        int time = DtimeAPI.getTime(playName);
        lore.add("§a§l★§7今日活跃: §a"+ time+"分钟");
        int rechargeMonth = RechargeAPI.getRechargeData(playName, TimeType.MONTHLY);
        lore.add("§a§l★§7本月充值: §b" + rechargeMonth + "软妹币");
        lore.add("");
        lore.add("§e§l★§7左键点击通过申请");
        lore.add("§c§l★§7右键点击拒绝申请");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbt = StackLibrary.getNBT(item);
        nbt.setString("ApplyName",playName);
        return StackLibrary.setNBT(item,nbt);
    }
}
