package me.Demon.DemonShiTu.listener;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.manager.DataManager;
import me.Demon.ItemKuAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.ItemStack;


public class itemUse implements Listener {

    @EventHandler
    public void onUseJoin(PlayerInteractEvent e){
        Player p = e.getPlayer();
        String name = p.getName();
        ItemStack item = p.getInventory().getItemInMainHand();
        if(e.getHand() == EquipmentSlot.HAND) {
            Action action = e.getAction();
            if (action == Action.LEFT_CLICK_AIR || action == Action.RIGHT_CLICK_BLOCK) {
                ItemStack needStack = ItemKuAPI.getItems("出师令", 1);
                if(DemonAPI.isMainHandItemsLore(p,needStack,1)){
                    // 判断这个玩家是否已有师傅档案
                    if(ShiTuAPI.isTeacherExit(name)){
                        DemonAPI.sendMessage(p,"你已经出师了,无法使用此道具.");
                        return;
                    }
                    if (item.getAmount() == 1) {
                        p.getInventory().setItemInMainHand(new ItemStack(Material.AIR));
                    } else {
                        item.setAmount(item.getAmount() - 1);
                    }
                    // 创建出师档案
                    DataManager dataManager = Main.dataManager;
                    dataManager.createTeacherData(name);
                    DemonAPI.sendMessage(p,"成功注册出师档案,已完成 §e§l出师！");
                    Bukkit.broadcastMessage("§6[§c公告§6] §a玩家 §e"+p.getName()+" §a使用了 §r"+needStack.getItemMeta().getDisplayName()+" §a成功出师,开始收徒。");
                }
            }
        }
    }

    @EventHandler
    public void onUseDissolve(PlayerInteractEvent e){
        Player p = e.getPlayer();
        String name = p.getName();
        ItemStack item = p.getInventory().getItemInMainHand();
        if(e.getHand() == EquipmentSlot.HAND) {
            Action action = e.getAction();
            if (action == Action.LEFT_CLICK_AIR || action == Action.RIGHT_CLICK_BLOCK) {
                ItemStack needStack = ItemKuAPI.getItems("解除令", 1);
                if (DemonAPI.isMainHandItemsLore(p, needStack, 1)) {
                    DataManager dataManager = Main.dataManager;
                    // 判断这个玩家是否已有师傅档案
                    if (dataManager.isPlayerExitTeacher(name)) {
                        DemonAPI.sendMessage(p, "你还没有拜过师,无法使用此道具.");
                        return;
                    }
                    if (item.getAmount() == 1) {
                        p.getInventory().setItemInMainHand(new ItemStack(Material.AIR));
                    } else {
                        item.setAmount(item.getAmount() - 1);
                    }
                    String sfName = dataManager.getTeacherName(name);// 获取这个玩家的师傅名
                    ShiFuData fuData = dataManager.getTeacherData(sfName);// 获取这个玩家的师傅档案
                    if (fuData == null) {
                        DemonAPI.sendMessage(p, "师傅的档案数据出现异常.§7#" + sfName);
                        return;
                    }
                    fuData.removeTudiList(name); // 将玩家从徒弟列表踢出.
                    fuData.SaveData(); // 保存数据
                    DemonAPI.sendMessage(p,"已经和 §e"+sfName+" §a解除师徒关系.");
                }
            }
        }
    }
}
