package me.Demon.DemonShiTu.manager;

import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.data.ShiFuData;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class DataManager {

    private long monthlyTimeLog;
    private long everydayTimeLog;
    private HashMap<String, ShiFuData> shiFuDataMap = new HashMap<>();
    private HashMap<String, List<String>> apprenticeList = new HashMap<>();
    private HashMap<String, List<String>> applyForList = new HashMap<>();
    private List<String> activeReward = new ArrayList<>();

    public DataManager(){
        FileConfiguration yml = Main.plugin.getConfig();
        monthlyTimeLog = yml.getLong("monthlyTimeLog");
        everydayTimeLog = yml.getLong("everydayTimeLog");
        ConfigurationSection section = yml.getConfigurationSection("ShiTuData");
        if(section == null) {return;}
        for (String shifuName : section.getKeys(false)){
            int level =  section.getInt(shifuName+".level");
            double shouyi = section.getDouble(shifuName+".shouyi");
            long loginTime = section.getLong(shifuName+".loginTime");
            if(loginTime < 0){
                loginTime = System.currentTimeMillis();
            }
            List<String> stringList = section.getStringList(shifuName+".tudi");
            shiFuDataMap.put(shifuName,new ShiFuData(shifuName,level,shouyi,stringList,loginTime));
            apprenticeList.put(shifuName,stringList);
        }
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f每月结算 §8> §6"+DemonAPI.LongToStringData(monthlyTimeLog,"yyyy年MM月"));
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f每日刷新 §8> §6"+DemonAPI.LongToStringData(everydayTimeLog,"MM月dd日"));
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f师傅档案 §8> §6"+shiFuDataMap.size()+"名");
        DemonAPI.sendConsoleMessage("§f[§a!§f] §f活跃奖励 §8> §6"+activeReward.size()+"名");
    }

    public void SaveDataManager(){
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("monthlyTimeLog",monthlyTimeLog);
        yml.set("everydayTimeLog",everydayTimeLog);
        yml.set("activeReward",null);
        yml.set("activeReward",activeReward);
        for (String sfName : shiFuDataMap.keySet()){
            ShiFuData fuData = shiFuDataMap.get(sfName);
            if(fuData.isLoginOvertime()){
                // yml.set("ShiTuData."+sfName,null);
                System.out.println("[调试 - 师徒] 由于玩家 "+sfName+" 长时间未上线,他的师徒档案已清理.");
            }
            fuData.SaveData();
        }
        System.out.println("[调试 - 师徒] 活跃收益 "+activeReward.size()+" 名");
        System.out.println("[调试 - 师徒] 已保存 "+shiFuDataMap.size()+" 师傅的数据档案");
    }

    public long getMonthlyTimeLog() {
        return monthlyTimeLog;
    }

    public void setMonthlyTimeLog(long monthlyTimeLog) {
        this.monthlyTimeLog = monthlyTimeLog;
    }

    public long getEverydayTimeLog() {
        return everydayTimeLog;
    }

    public void setEverydayTimeLog(long everydayTimeLog) {
        this.everydayTimeLog = everydayTimeLog;
    }

    public HashMap<String, ShiFuData> getShiFuDataMap() {
        return shiFuDataMap;
    }

    public void removeShiFuData(String sfName) {
        this.shiFuDataMap.remove(sfName);
        FileConfiguration yml = Main.plugin.getConfig();
        yml.set("ShiTuData."+sfName,null);
        Main.plugin.saveConfig();
    }

    public List<String> getApplyForList(String sfName) {
        List<String> stringList = new ArrayList<>();
        if(this.applyForList.get(sfName) == null){
            return stringList;
        }
        stringList.addAll(applyForList.get(sfName));
        return stringList;
    }

    public void setApplyForList(String sfName,List<String> applyForList) {
        this.applyForList.put(sfName,applyForList);
    }

    // 获取学徒列表
    public List<String> getApprenticeList(String name){
        if(this.apprenticeList.get(name) != null){
            return apprenticeList.get(name);
        }
        return new ArrayList<>();
    }

    public boolean isActiveReward(String name){
        if(activeReward.contains(name)){
            return true;
        }
        return false;
    }

    public List<String> getActiveReward() {
        return activeReward;
    }

    public void setActiveReward(List<String> activeReward) {
        this.activeReward = activeReward;
    }

    public ShiFuData getTeacherData(String sfName){
        if(this.shiFuDataMap.get(sfName) != null){
            return shiFuDataMap.get(sfName);
        }
        return null;
    }

    public boolean isPlayerExitTeacher(String name){
        for (String teacherName : this.apprenticeList.keySet()){
            List<String> stringList = this.apprenticeList.get(teacherName);
            if(stringList.contains(name)){
                return true;
            }
        }
        return false;
    }

    public String getTeacherName(String name){
        for (String teacherName : this.apprenticeList.keySet()){
            List<String> stringList = this.apprenticeList.get(teacherName);
            if(stringList.contains(name)){
                return teacherName;
            }
        }
        return "无";
    }

    public void createTeacherData(String sfName){
        int level = 1;
        double shouyi = 0.0;
        long loginTime = System.currentTimeMillis();
        List<String> stringList = new ArrayList<>();
        shiFuDataMap.put(sfName,new ShiFuData(sfName,level,shouyi,stringList,loginTime));
        apprenticeList.put(sfName,stringList);
        shiFuDataMap.get(sfName).SaveData();
    }
}
